//---------------------------------------------------------------------------------
//^`
//---------------------------------------------------------------------------------

struct VS_OUT
{
   	float4 Pos        : POSITION;
   	float3 Light      : TEXCOORD0;
   	float3 Normal     : TEXCOORD1;
   	float3 View       : TEXCOORD2;    
   	float2 DecalTC    : TEXCOORD3;
   	float4 ShadowTC   : TEXCOORD4;
	float4 DepthValue : TEXCOORD5;	
};

//---------------------------------------------------------------------------------
//O[o
//---------------------------------------------------------------------------------

float4x4 mW; 
float4x4 mWCP;
float4x4 mWLP;
float4x4 mWLPT;

float4 Diffuse;     //gUˌ
float4 vecLightDir; //CgxNg
float4 vecEye;      //JW

float TexWidth  = 1024; //[xeNX`
float TexHeight = 1024; //[xeNX`c
 
//[xeNX`
texture DepthTex;
sampler DepthSampler = sampler_state
{
	Texture   = ( DepthTex );
	MinFilter = Point;
    MagFilter = Point;
    MipFilter = NONE;
    AddressU  = Clamp;
    AddressV  = Clamp;
};

//eNX`
texture DecalTexture;
sampler DecalSampler = sampler_state
{
	Texture   = ( DecalTexture );
	MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU  = Clamp;
    AddressV  = Clamp;
};

//---------------------------------------------------------------------------------
//VhE}bv쐬p@o[ebNXEVF[_[
//---------------------------------------------------------------------------------

VS_OUT VS_Depth( float4 Pos : POSITION ) 
{
	VS_OUT Out = ( VS_OUT )0;

	Out.Pos        = mul( Pos , mWLP ); 
	Out.DepthValue = Out.Pos;

	return Out;
}

//---------------------------------------------------------------------------------
//VhE}bv쐬p@sNZEVF[_[
//---------------------------------------------------------------------------------

float4 PS_Depth( VS_OUT In ) : COLOR
{
	float4 FinalColor;
	
	FinalColor = In.DepthValue.z / In.DepthValue.w;
	
	//ŏIIȐFԂ
	return FinalColor;
}

//---------------------------------------------------------------------------------
// VhE}bv쐬p@eNjbN
//---------------------------------------------------------------------------------

technique tecMakeDepthTexture
{
    pass p0
    {    
		VertexShader = compile vs_1_1 VS_Depth();
        PixelShader  = compile ps_2_0 PS_Depth(); 
    }
}

//---------------------------------------------------------------------------------
//V[_Op@o[ebNXEVF[_[
//---------------------------------------------------------------------------------

VS_OUT VS_Scene( float4 Pos    : POSITION,
				 float3 Normal : NORMAL,
				 float2 TC     : TEXCOORD0
			   ) 
{
	VS_OUT Out = ( VS_OUT )0;

	Out.Pos        = mul( Pos , mWCP ); 
	Out.Light      = vecLightDir;
    Out.View       = vecEye -normalize( mul( Pos , mW ) );
    Out.Normal     = mul( Normal, mW ); 	    
	Out.DecalTC    = TC;
	Out.ShadowTC   = mul( Pos , mWLPT );      //eNX`WCgԂɃ}bsOB
	Out.DepthValue = mul( Pos , mWLP ) - 0.9; //eȂȂ镔ł邪ȁXóc
	
	return Out;
}

//---------------------------------------------------------------------------------
//V[_Op@sNZEVF[_[
//---------------------------------------------------------------------------------

float4 PS_Scene( VS_OUT In ) : COLOR
{
	float4 FinalColor;
	
	float3 Normal   = normalize( In.Normal ); //@K
    float3 LightDir = normalize( In.Light );  //CgxNgK
    float3 ViewDir  = normalize( In.View );   //JK

	//CgxNgƖ@̓
    float4 NL = saturate( dot( Normal , LightDir ) );

	//˃xNgvZ
    float3 Reflect = normalize( 2 * NL * Normal - LightDir );

	//ʔˌvZ
    float4 Specular = pow( saturate( dot( Reflect, ViewDir ) ), 4); 

	//e̕łȂ΁A̎_̃J[ŏIJ[
    FinalColor = ( Diffuse + tex2D( DecalSampler , In.DecalTC ) ) * NL;
  
	//eNX`WCgԂɃ}bsOB
	float Shadow = tex2Dproj( DepthSampler , In.ShadowTC ).r;
	
	//eȂF
	if( Shadow * In.DepthValue.w < In.DepthValue.z )
	{
		FinalColor /= 4;
	}

	//IɃAt@lPɌŒ肷
	FinalColor.a = 1.0f;

	//ŏIIȐFԂ
	return FinalColor;
}

//---------------------------------------------------------------------------------
// V[_Op@eNjbN
//---------------------------------------------------------------------------------

technique tecRenderScene
{     
    pass p0    
    {   
		VertexShader = compile vs_1_1 VS_Scene();
        PixelShader  = compile ps_2_0 PS_Scene();
    }
}