//==============================================================
//萔
float4x4     WVP;
float4x4   World;
float4   Diffuse;
float4    VecEye;
float4     Light;
float      Alpha;
int          Flg;
texture      Tex;

//==============================================================
//eNX`Tv
sampler TexSmp = sampler_state {
	Texture   = <Tex>;
	MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU  = Clamp;
    AddressV  = Clamp;

};

//==============================================================
//^`
struct SHEDAR
{
	float4 Pos    : POSITION;
	float3 Light  : TEXCOORD0;
	float3 Normal : TEXCOORD1;
	float3 View   : TEXCOORD2;
	float2 Tex    : TEXCOORD3;
};

//==============================================================
//_VF[_[
SHEDAR BasicVS
(
	float4     pos        : POSITION,  //W
	float3     normal     : NORMAL,    //@
	float2     tex        : TEXCOORD0  //eNX`W
){

	SHEDAR Out = (SHEDAR)0;

	//Wϊ
	Out.Pos = mul(pos,WVP);

	//eNX`W
	Out.Tex = tex;

	//Cg
	Out.Light = Light;

	//J̈ʒu߂
	Out.View = -VecEye + normalize( mul( pos,World ) );

	//@
    Out.Normal = mul( normal , World ); 

	return Out;

}

//==============================================================
//sNZVF[_[
float4 BasicPS
(
	SHEDAR In

) : COLOR 
{

	float4 FinalColor;

	//K
	float3 Normal   = normalize( In.Normal );
	float3 LightDir = normalize( In.Light );
	float3 ViewDir  = normalize( In.View );

	//CgxNgƖ@̓
    float4 NL = saturate( dot( Normal , LightDir ) );

	//˃xNgvZ
    float3 Reflect = normalize( 2 * NL * Normal - LightDir );

	//ʔˌvZ
    float4 Specular = pow( saturate( dot( Reflect, ViewDir ) ), 4); 

	//e̕łȂ΁A̎_̃J[ŏIJ[
	FinalColor = Diffuse * NL + Specular;

	if( Flg )
		FinalColor = FinalColor * tex2D( TexSmp , In.Tex );

	//At@lݒ
	FinalColor.a = Alpha;

	return FinalColor;

}

//==============================================================
//eNjbN
technique Basic {
	pass P0 {
		VertexShader = compile vs_1_1 BasicVS();
		PixelShader  = compile ps_2_0 BasicPS();
	}
}
